const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const deal_products = sequelize.define(
    'deal_products',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

unit_price: {
        type: DataTypes.DECIMAL,
      
      

      },

quantity: {
        type: DataTypes.INTEGER,
      
      

      },

discount_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  deal_products.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















//end loop



    db.deal_products.belongsTo(db.deals, {
      as: 'deal',
      foreignKey: {
        name: 'dealId',
      },
      constraints: false,
    });




    db.deal_products.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.deal_products.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return deal_products;
};


